//Multi-Team Campaign Stdlib
//By Dungat
//Thanks go to Dolf Kooz for coming up with a lot of the campaign code
//Thanks to Zephyr for the idea.
//Thanks to Orogogus for the server logging stuff, and his help with making the server work
//Thanks to everybody who helped debug the dumb thing
///////////////////////////////Global Variables///////////////////////////////////////////////////////////////////////
//$<Team>Race= "Rebel", "Empire", "Promethean", "Metagen","Alliance","NONE"
//(Used for tech distribution. "Allow tech mixing" doesn't cover factional distinctions, only racial ones
//$RedBriefing= string describing mission briefing for Red Team
//$YellowBriefing= string describing mission briefing for Yellow Team
//$PurpleBriefing= string describing mission briefing for Purple Team
//$BlueBriefing= string describing mission briefing for Blue Team
//$MissionHistorical= string describing the historical background for the mission
//$SpecialRules= string describing any deviations from normal play

exec("multiplayerStdlib.cs");
$combatSlowdown=150;	//This is how much heal a player gets for attacking another
function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	
	$server::TeamDamage=true;
	$server::AllowMixedTech=false;
	setIndividualSettings();
}

function teamStringToVariableName(%string)
{
	if (%string==*IDSTR_TEAM_YELLOW) return "Yellow";
	if (%string==*IDSTR_TEAM_RED) return "Red";
	if (%string==*IDSTR_TEAM_BLUE) return "Blue";
	if (%string==*IDSTR_TEAM_PURPLE) return "Purple";
}

function onMissionLoad()
{
	echo("MISSION LOADING");
	$missionStarted=false;
	$RedTeamLives=true;
	$YellowTeamLives=true;
	$BlueTeamLives=true;
	$PurpleTeamLives=true;
	setIndividualSettings();	//For dedicated servers
	playerLoop("",".entry=\"Allowed\";","all");	//For restarts
	%information1= "<F2>GAME TYPE: \n<F0>Multi-team Campaign\n\n<tIDMULT_TDM_MAPNAME>"@$missionName
		@"\n\n<F2>HISTORICAL BACKGROUND:\n<F0>";
	%information2= "\n<F2>TEAMS:\n<F0>";
	if ($YellowRace!="NONE") %information2= %information2@"          Yellow Team:  "@$YellowRace@"\n";
	if ($RedRace!="NONE") %information2= %information2@"          Red Team:  "@$RedRace@"\n";
        if ($BlueRace!="NONE") %information2= %information2@"          Blue Team:  "@$BlueRace@"\n";
        if ($PurpleRace!="NONE") %information2= %information2@"          Purple Team:  "@$PurpleRace@"\n";
	%information2= %information2@"<F2>FLYER POLICY:\n<F0>This server is not flyer-friendly. Sorry. They interfere"
		@" with the start zone code too much.";
	setGameInfo(%information1 @ $MissionHistorical @ %information2);
	initVehicles();
	initVariables();
	initSounds();
	schedule("initDistanceChecks();",5);
	echo("MISSION LOADED");
	%nowDate = getDate();
	%nowTime = getTime();
	%outputString =  %nowDate @ ", " @ %nowTime @ " -- Mission \""@ $missionName @"\" loaded.";
	filewrite("multiplayer\\serverlog.txt", append, %outputString);
}
///////////////////////////////Player Manager////////////////////////////////////////////////////////////////////////////////
function player::onAdd(%who)
{
	if(strAlign(1, left, getname(%who))=="/") 
	{ 
	say(0,0,"<f4>" @ getName(%who) @ " joined the game with a slash", "alarm2.wav"); 
	} 
	%who.entry= "Allowed";
	say(%who, 0, "Welcome to Multiple Team Campaign Games<F7> by <F1>Dungat<F7>. Send comments or questions to "
		@"<F2>krzys0\@canada.enoreo.on.ca<F7>.");
//	say(%who,0, %string1@%string2@%string3@%string4@%string5@%string6@%string7);
	if ($missionStarted) say(%who,0,"<F2>There is a game in progress. Please wait for a reinforcement wave or for"
		@" the next mission.");
	%string1= "Player configs are severely restricted by their teams for realism. Members of an \"Empire\" team, for "
		@"example, will only be able to use human and common technology. Members of an \"Alliance\" team can use "
		@"common, human, or alien technology, and so on. ";
	%string2= "Check the teams under the player info tab. You will be killed if you join the game in an inappropriate "
		@"vehicle. Instructions not pertaining to configs can be found by scanning the help pylon located at "
		@"each starting location. Goto Nav King's Area.";
	messageBox(%who, %string1);
	messageBox(%who, %string2);

  %nowDate = getDate();
  %nowTime = getTime();
  %outputString =  %nowDate@","@%nowTime@"--"@getName(%who)@" joined the game ("@getConnection(%who)@ ")";
  echo(%outputString);
  filewrite("multiplayer\\serverlog.txt", append, %outputString);
}

function player::onRemove(%who)
{
  if(strAlign(1, left, getname(%who))=="/") 
  { 
     say(0,0,"<f4>" @ getName(%who) @ " left the game with a slash", "alarm2.wav"); 
  } 
  %nowDate = getDate();
  %nowTime = getTime();
  %outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ getName(%who) @ " left the game";
  echo(%outputString);
  filewrite("multiplayer\\serverlog.txt", append, %outputString);
}

function vehicle::onAdd(%who)
{
	%player=playerManager::vehicleIdToPlayerNum(%who);
	if ((%player==0)||(%player==" ")) return;
	if (%player.entry== "Forbidden") {damageObject(%who,30000); say(%player,0,"You are not allowed to join. Please wait until the next game or for a reinforcement wave."); fileWrite("multiplayer\\serverlog.txt", append, getName(%who)@" entered in a no-respawn situation"); return;}
	if ((%player.entry== "Allowed")&&($missionStarted)) {damageObject(%who,30000); say(%player,0,"You are not allowed to join. Please wait until the next game or for a reinforcement wave."); fileWrite("multiplayer\\serverlog.txt", append, getName(%who)@" entered in a no-respawn situation"); return;}
	//Alternatives are that the player has a special entry flag and/or that mission has not started
	testPlayerConfig(%who);
	schedule("if ((checkIfPlayerDead("@%player@")==\"ALIVE\")&&(!$missionStarted)) "@
	"{messageBox("@%player@",$"@teamStringToVariableName(getTeam(%who))@"Briefing1); "@
	"messageBox("@%player@",$"@teamStringToVariableName(getTeam(%who))@"Briefing2);}",5);
	schedule("$"@teamStringToVariableName(getTeam(%who))@"TeamLives=true;",0);	//Makes sure the variable isnt false when it should be true
	vehicleOnAddSpecial(%who);
	say(%player,0,$SpecialRules);
	%nowDate = getDate();
	%nowTime = getTime();
	%outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ getHudName(%who) @ "("@ getTeam(%who) @") entered the map in a " @ getVehicleName(%who);
	echo(%outputString);
	filewrite("multiplayer\\serverlog.txt", append, %outputString);
}

function vehicle::onAttacked(%attackee, %attacker)
{
	%player=playerManager::vehicleIdToPlayerNum(%attacker);
	if ((%player==0)||(%player==" ")) return;
	healObject(%attacker,$combatSlowdown);
}

function vehicle::onDestroyed(%destroyee, %destroyer)
{
	reloadObject(%destroyer,10000);
//	healObject(%destroyer,6000);	//I kind of like the combatSlowdown thing...
	%player=playerManager::vehicleIdToPlayerNum(%destroyee);
	if ((getTeam(%destroyee)==getTeam(%destroyer))&&(%destroyee!=%destroyer))	//Teamkiller!
	{
		antiTeamKill(%destroyer);						//Thou shalt be punished
		filewrite("multiplayer\\serverlog.txt", append, getHUDName(%destroyer)@" teamkilled "@getHUDName(%destroyee));
		%player.entry= "Special";						//Victim may reenter
	}
	else if (!$missionStarted) %player.entry= "Allowed";				//Player can still enter
	else %player.entry= "Forbidden";						//Time to wait
	if (%destroyee!=%destroyer) vehicleOnDestroyedSpecial(%destroyee);		//illegal entries do not trigger special
	%message = getFancyDeathMessage(getHUDName(%destroyee), getHUDName(%destroyer));
	if(%message != "")
	{
		if ($missionStarted) say( 0, 0, %message);
		else if (%destroyer==%destroyee) say(0,0, getHUDName(%destroyee)@" has left the map.");	//Player killed himself before mission began
	}
	schedule("if (($missionStarted)&&($"@teamStringToVariableName(getTeam(%destroyee))@"TeamLives)) checkForTeamDead(getTeam("@%destroyee@"));",0);	//Bugs can result if this function run before mission start
	%consoleMessage= getDate()@","@getTime()@" -- "@getHUDName(%destroyer) @ " killed " @ getHUDName(%destroyee);
	echo(%consoleMessage);
	filewrite("multiplayer\\serverlog.txt", append, %consoleMessage);
}

function resetTeam(%vehicle)	//Cannot do reset based on vehicle type, because some vehicles may be allowed on more than one team, e.g. Imperial and Alliance both would use a Knight's Apocalypse
{
	if($YellowRace!="NONE") setTeam(%vehicle, *IDSTR_TEAM_YELLOW); return;
	if($PurpleRace!="NONE") setTeam(%vehicle, *IDSTR_TEAM_PURPLE); return;
	if($RedRace!="NONE") setTeam(%vehicle, *IDSTR_TEAM_RED); return;
	if($BlueRace!="NONE") setTeam(%vehicle, *IDSTR_TEAM_BLUE);
}

function testPlayerConfig(%vehicle)
{
	echo("TESTING CONFIG...");
	%player=playerManager::vehicleIdToPlayerNum(%vehicle);
	%death=false; %guns=true; %specials=true;
	%team= getTeam(%vehicle);
	if (%team==*IDSTR_TEAM_YELLOW)
		%teamAffiliation=$YellowRace;
	if (%team==*IDSTR_TEAM_Red)
		%teamAffiliation=$RedRace;
	if (%team==*IDSTR_TEAM_BLUE)
		%teamAffiliation=$BlueRace;
	if (%team==*IDSTR_TEAM_PURPLE)
		%teamAffiliation=$PurpleRace;
	if (%teamAffiliation=="NONE")	//Illegal team
	{
		resetTeam(%vehicle); redrop(%vehicle); return;	//Player::onAdd run for redrop?
	}
	%nowDate = getDate();
	%nowTime = getTime();
	%outputString = "The team was " @ %teamAffiliation;
	%outputString = %outputString @ "\nThe vehicle was a(n) " @ getVehicleName(%vehicle)@ "\nARMAMENT";
	%warning="Sorry, your config is not acceptable for your team.";
	%vehicleTech=identifyVehicleTechBase(%vehicle);
        if ((%teamAffiliation=="Alliance")&&((%vehicleTech=="Empire")||(%vehicleTech=="Rebel")))
		%vehicleTech="Alliance";
	if (((%teamAffiliation=="Promethean")||(%teamAffiliation=="Metagen"))&&(%vehicleTech=="Cybrid"))
		%vehicleTech=%teamAffiliation;
	if(%vehicleTech!=%teamAffiliation)
	{
	messageBox(%player,"The "@getVehicleName(%vehicle)@" is not allowed on the "@%team@". Change teams or use a different chassis.");
	damageObject(%vehicle,30000);
	%outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ getHUDName(%vehicle) @ " was booted from the map for using the following vehicle:\n" @%outputString;
	return;
	}
	%weaponCount= getWeaponCount(%vehicle);
        for(%i=0; %i<%weaponCount; %i++)
	{
		%weapon= getWeaponId(%vehicle,%i);
		%weaponTech= identifyWeaponTechBase(%weapon);
		%outputString = %outputString @ "\n" @ getWeaponName(%weapon) @"("@%weaponTech@")";
		echo(%weaponTech);
                if ((%teamAffiliation=="Metagen")&&(%weaponTech=="Cybrid")) %weaponTech="Metagen";       //Common weapons
		if ((%teamAffiliation=="Promethean")&&(%weaponTech=="Cybrid")) %weaponTech="Promethean"; //Common weapons
                if ((%teamAffiliation=="Rebel")&&(%weaponTech=="Alliance")) %weaponTech="Rebel";         //Use same weapons
                if ((%teamAffiliation=="Empire")&&(%weaponTech=="Alliance")) %weaponTech="Empire";       //Use same weapons
                if ((%teamAffiliation=="Alliance")&&((%weaponTech=="Empire")||(%weaponTech=="Rebel"))) %weaponTech="Alliance";    //Pooled resources
		if (%weaponTech=="NONE") %weaponTech=%teamAffiliation;		//Dont get killed for lack of a gun or a common weapon
		if (%teamAffiliation!=%weaponTech) {%death=true; %warning=%warning@"\nILLEGAL WEAPON: "@getWeaponName(%weapon);}
	}
	%outputString = %outputString @ "\nEQUIPMENT";
	%componentCount= getComponentCount(%vehicle);
        for(%i=0; %i<%componentCount; %i++)
	{
		%component= getComponentId(%vehicle,%i);
                %componentTech= identifyComponentTechBase(%component);
		%outputString = %outputString @ "\n" @ getComponentName(%component) @"("@%componentTech@")";
		echo(%componentTech);
                if ((%teamAffiliation=="Metagen")&&(%componentTech=="Cybrid")) %componentTech="Metagen"; //Common components
                if ((%teamAffiliation=="Promethean")&&(%componentTech=="Cybrid")) %componentTech="Promethean"; //Common components
                if ((%teamAffiliation=="Rebel")&&(%componentTech=="Alliance")) %componentTech="Rebel";   //Use same components
                if ((%teamAffiliation=="Empire")&&(%componentTech=="Alliance")) %componentTech="Empire"; //Use same components
                if ((%teamAffiliation=="Alliance")&&((%componentTech=="Empire")||(%componentTech=="Rebel"))) %componentTech="Alliance";   //Pooled resources
                if (%componentTech=="NONE") %componentTech=%teamAffiliation;               //Dont get killed for lack of a components or a common components
		if (%teamAffiliation!=%componentTech) {%death=true; %warning=%warning@"\nILLEGAL COMPONENT: "@getComponentName(%component);}
	}
	%player=playerManager::vehicleIdToPlayerNum(%vehicle);
	echo("TEAM IS " @%teamAffiliation);
	if (%death==true)
	{
		messageBox(%player,%warning);
		damageObject(%vehicle,30000);
	%outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ getHUDName(%vehicle) @ " was booted from the map for using the following vehicle:\n" @%outputString;
	}
	%outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ getHUDName(%vehicle) @ " entered in the following vehicle:\n" @%outputString;
	//filewrite("multiplayer\\serverlog.txt", append, %outputString);
	echo("TESTING COMPLETE");
}

function identifyVehicleTechBase(%vehicle,%race)
{
	%type= getVehicleName(%vehicle);
	%alliance=false;
	if (%race=="Alliance") %alliance=true;

	if (%type=="Talon") %answer="Empire";
	if (%type=="Knight's Talon") %answer="Empire";
	if (%type=="Minotaur") %answer="Empire";
	if (%type=="Knight's Minotaur") %answer="Empire";
	if (%type=="Basilisk") %answer="Empire";
	if (%type=="Knight's Basilisk") %answer="Empire";
	if (%type=="Apocalpyse") %answer="Empire";
	if (%type=="Knight's Apocalypse") %answer="Empire";
	if (%type=="Gorgon") %answer="Empire";
	if (%type=="Knight's Gorgon") %answer="Empire";
	if (%type=="Emancipator") %answer="Rebel";
	if (%type=="Outrider Emancipator") %answer="Rebel";
	if (%type=="Olympian") %answer="Rebel";
	if (%type=="Avenger") %answer="Rebel";
	if (%type=="Dreadlock") %answer="Rebel";
	if (%type=="Disrupter") %answer="Empire";
	if (%type=="Myrmidon") %answer="Empire";
	if (%type=="Paladin") %answer="Empire";
	if (%type=="Knight's Disrupter") %answer="Empire";
	if (%type=="Knight's Myrmidon") %answer="Empire";
	if (%type=="Knight's Paladin") %answer="Empire";
	if (%type=="Harabec's Predator")  %answer="Rebel";
	if (%type=="Seeker") %answer="Promethean";
	if (%type=="Metagen Seeker") %answer="Metagen";
	if (%type=="Goad") %answer="Promethean";
	if (%type=="Metagen Goad") %answer="Metagen";
	if (%type=="Shepherd") %answer="Promethean";
	if (%type=="Metagen Shepherd") %answer="Metagen";
	if (%type=="Adjudicator") %answer="Promethean";
	if (%type=="Platinum Guard Adjudicator") %answer="Promethean";
	if (%type=="Executioner") %answer="Promethean";
	if (%type=="Platinum Guard Executioner") %answer="Promethean";
	if (%type=="Bolo") %answer="Cybrid";
	if (%type=="Recluse") %answer="Promethean";
	if (%type=="Recluse") %answer="Cybrid";	//Balance is needed
	echo(%answer);
	return %answer;
}

function identifyWeaponTechBase(%id)
{
	if (%id==3) return "Empire";
	if (%id==101) return "NONE";		//Allowed for all, so treated as lack of weapon
	if (%id==102) return "NONE";
	if (%id==103) return "Alliance";	//Here, this means "Human"
	if (%id==104) return "Cybrid";
	if (%id==105) return "NONE";
	if (%id==106) return "Alliance";
	if (%id==107) return "Rebel";
	if (%id==108) return "Rebel";
	if (%id==109) return "Cybrid";
	if (%id==110) return "Empire";
	if (%id==111) return "Cybrid";
	if (%id==112) return "Rebel";
	if (%id==113) return "Rebel";
	if (%id==114) return "Cybrid";
	if (%id==115) return "Rebel";
	if (%id==116) return "NONE";
	if (%id==117) return "NONE";
	if (%id==118) return "Cybrid";
	if (%id==119) return "NONE";
	if (%id==120) return "NONE";
	if (%id==121) return "Cybrid";
	if (%id==124) return "NONE";
	if (%id==125) return "NONE";
	if (%id==126) return "NONE";
	if (%id==127) return "NONE";
	if (%id==128) return "Empire";
	if (%id==129) return "NONE";
	if (%id==130) return "Cybrid";
	if (%id==131) return "Cybrid";
	if (%id==132) return "Cybrid";
	if (%id==133) return "Cybrid";
	if (%id==134) return "NONE";
	if (%id==135) return "NONE";
	if (%id==136) return "NONE";
	if (%id==142) return "Cybrid";
	if (%id==147) return "NONE";
	if (%id==150) return "Rebel";
	if (%id==0) return "NONE";
	return "ERROR";
}

function identifyComponentTechBase(%id)
{
	if (%id==100) return "Alliance";
	if (%id==101) return "Alliance";
	if (%id==102) return "Alliance";
	if (%id==103) return "Alliance";
	if (%id==104) return "Alliance";
	if (%id==105) return "Alliance";
	if (%id==106) return "Alliance";
	if (%id==107) return "Alliance";
	if (%id==108) return "Alliance";
	if (%id==109) return "Alliance";
	if (%id==110) return "Alliance";
	if (%id==111) return "Alliance";
	if (%id==112) return "Alliance";
	if (%id==113) return "Alliance";
	if (%id==114) return "Alliance";
	if (%id==115) return "Alliance";
	if (%id==127) return "Cybrid";
	if (%id==129) return "Cybrid";
	if (%id==130) return "Cybrid";
	if (%id==131) return "Cybrid";
	if (%id==132) return "Cybrid";
	if (%id==133) return "Cybrid";
	if (%id==134) return "Cybrid";
	if (%id==135) return "Cybrid";
	if (%id==136) return "Cybrid";
	if (%id==137) return "Cybrid";
	if (%id==138) return "Cybrid";
	if (%id==139) return "Cybrid";
	if (%id==140) return "Cybrid";
	if (%id==141) return "Cybrid";
	if (%id==142) return "Cybrid";
	if (%id==143) return "Cybrid";
	if (%id==200) return "Alliance";
	if (%id==201) return "Alliance";
	if (%id==202) return "Alliance";
	if (%id==203) return "Alliance";
	if (%id==204) return "Alliance";
	if (%id==205) return "Alliance";
	if (%id==225) return "Cybrid";
	if (%id==226) return "Cybrid";
	if (%id==227) return "Cybrid";
	if (%id==228) return "Cybrid";
	if (%id==229) return "Cybrid";
	if (%id==230) return "Cybrid";
	if (%id==300) return "Alliance";
	if (%id==301) return "Alliance";
	if (%id==302) return "Alliance";
	if (%id==303) return "Alliance";
	if (%id==304) return "Alliance";
	if (%id==305) return "Alliance";
	if (%id==306) return "Alliance";
	if (%id==307) return "Alliance";
	if (%id==310) return "Cybrid";
	if (%id==327) return "Cybrid";
	if (%id==328) return "Cybrid";
	if (%id==329) return "Cybrid";
	if (%id==330) return "Cybrid";
	if (%id==331) return "Cybrid";
	if (%id==332) return "Cybrid";
	if (%id==333) return "Cybrid";
	if (%id==400) return "Alliance";
	if (%id==401) return "Alliance";
	if (%id==408) return "Alliance";
	if (%id==409) return "Alliance";
	if (%id==410) return "Alliance";
	if (%id==411) return "Alliance";
	if (%id==412) return "Alliance";
	if (%id==413) return "Alliance";
	if (%id==414) return "Alliance";
	if (%id==426) return "Cybrid";
	if (%id==427) return "Cybrid";
	if (%id==428) return "Cybrid";
	if (%id==429) return "Cybrid";
	if (%id==430) return "Cybrid";
	if (%id==431) return "Cybrid";
	if (%id==432) return "Cybrid";
	if (%id==433) return "Cybrid";
	if (%id==434) return "Cybrid";
	if (%id==800) return "Alliance";
	if (%id==801) return "Alliance";
	if (%id==802) return "Alliance";
	if (%id==805) return "Cybrid";
	if (%id==806) return "Cybrid";
	if (%id==807) return "Cybrid";
	if (%id==810) return "Alliance";
	if (%id==811) return "Alliance";
	if (%id==812) return "Cybrid";
	if (%id==813) return "Cybrid";
	if (%id==820) return "NONE";
	if (%id==830) return "Rebel";
	if (%id==831) return "Rebel";
	if (%id==840) return "NONE";
	if (%id==845) return "NONE";
	if (%id==850) return "NONE";
	if (%id==860) return "NONE";
	if (%id==865) return "NONE";
	if (%id==870) return "NONE";
	if (%id==875) return "NONE";
	if (%id==880) return "NONE";
	if (%id==885) return "NONE";
	if (%id==890) return "Rebel";
	if (%id==900) return "Alliance";
	if (%id==910) return "Rebel";
	if (%id==912) return "Alliance";
	if (%id==914) return "Rebel";
	if (%id==926) return "NONE";
	if (%id==927) return "NONE";
	if (%id==928) return "NONE";
	if (%id==929) return "NONE";
	if (%id==930) return "NONE";
	if (%id==931) return "Rebel";
	if (%id==0) return "NONE";
	return "ERROR";
}
///////////////////////////////Mission Functions/////////////////////////////////////////////////////////////////////////////
function reinforcementWave(%team)
{
	%playerCount = playerManager::getPlayerCount();
	for (%p = 0; %p < %playerCount; %p++)
	{
		%player = playerManager::getPlayerNum( %p );
		%vehicle = playerManager::playerNumToVehicleId( %player);
		if (getTeam(%vehicle)==%team)
		{
		%player.entry="Special";
		say(%player,0,"<F4>Your side has received reinforcements! You may join now.");
		}
	}
	%nowDate = getDate();
	%nowTime = getTime();
	%outputString =  %nowDate @ ", " @ %nowTime @ " -- The "@%team@" has received reinforcements!";
	filewrite("multiplayer\\serverlog.txt", append, %outputString);
}

function checkForTeamDead(%team)
{
	%varname= teamStringToVariableName(%team);
//	fileWrite("multiplayer\\serverlog.txt", append, "DEBUG: "@%team@" elimination checked with line "@"$"@%varname@"TeamLives=false;");
	%alive=0;
	%playerCount = playerManager::getPlayerCount();
	for (%p = 0; %p < %playerCount; %p++)
	{
		%player= playerManager::getPlayerNum(%p);
		if ((getTeam(%player)==%team)&&(checkIfPlayerDead(%player)=="ALIVE")) %alive++;
	}
	if ((%alive==0)&&($missionStarted))
	{
		schedule("$"@%varname@"TeamLives=false;",0);
//		schedule("reportTeamStatus();",5);
	}
        schedule("if (($RedTeamLives)&&(!$YellowTeamLives)&&(!$BlueTeamLives)&&(!$PurpleTeamLives))"@
                "RedTeamEliminates();",10);
        schedule("if ((!$RedTeamLives)&&($YellowTeamLives)&&(!$BlueTeamLives)&&(!$PurpleTeamLives))"@
                "YellowTeamEliminates();",10);
        schedule("if ((!$RedTeamLives)&&(!$YellowTeamLives)&&($BlueTeamLives)&&(!$PurpleTeamLives))"@
                "BlueTeamEliminates();",10);
        schedule("if ((!$RedTeamLives)&&(!$YellowTeamLives)&&(!$BlueTeamLives)&&($PurpleTeamLives))"@
                "PurpleTeamEliminates();",10);

        schedule("if ((!$RedTeamLives)&&(!$YellowTeamLives)&&(!$BlueTeamLives)&&(!$PurpleTeamLives))"@
                "allTeamsLose();",10);
}

function reportTeamStatus()
{
	filewrite("multiplayer\\serverlog.txt", append, "DEBUG: YellowTeamLives="@$YellowTeamLives);
	filewrite("multiplayer\\serverlog.txt", append, "DEBUG: PurpleTeamLives="@$PurpleTeamLives);
	filewrite("multiplayer\\serverlog.txt", append, "DEBUG: BlueTeamLives="@$BlueTeamLives);
	filewrite("multiplayer\\serverlog.txt", append, "DEBUG: RedTeamLives="@$RedTeamLives);
}

function allTeamsLose()         //It might happen!
{
  flushConsoleScheduler();
  messageBox(0, "All players died without completing their missions. The stats:\n"@
		" Yellow Team completed "@ countObjectives("Yellow")@" objectives\n"@
		" Red Team completed "@countObjectives("Red")@" objectives\n"@
		" Blue Team completed "@countObjectives("Blue")@" objectives\n"@
		" Purple Team completed "@countObjectives("Purple")@" objectives");
  missionendconditionmet();
}

function countObjectives(%string)
{
        %count=0;
	if (%string@Objective1Status==*IDSTR_OBJ_COMPLETED) %count++;
	if (%string@Objective2Status==*IDSTR_OBJ_COMPLETED) %count++;
	if (%string@Objective3Status==*IDSTR_OBJ_COMPLETED) %count++;
	if (%string@Objective4Status==*IDSTR_OBJ_COMPLETED) %count++;
	return %count;
}

///////////////////////////////Scoreboard////////////////////////////////////////////////////////////////////////////////////
//This game uses a modification of the standard campaign objective form:
//
//MissionModifiedObjective YellowObjective1
//{
//	isPrimary	= true;		(true/false= primary/secondary)
//	status		= *IDSTR_OBJ_ACTIVE;	(*IDSTR_OBJ_ followed by ACTIVE, COMPLETED, FAILED, IGNORE)
//	shortTxt	= "Destroy enemies.";	(short, in-battle summary)
//};

function getObjective1Status(%team)
{
	if (%team==1)
	{
	if (YellowObjective1.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (YellowObjective1.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (YellowObjective1.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}

	else if (%team==4)
	{
	if (RedObjective1.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (RedObjective1.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (RedObjective1.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}
	else if (%team==2)
	{
	if (BlueObjective1.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (BlueObjective1.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (BlueObjective1.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}
	else if (%team==8)
	{
	if (PurpleObjective1.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (PurpleObjective1.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (PurpleObjective1.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}
	else return %team;		//Debugging
}

function getObjective2Status(%team)
{
	if (%team==1)
	{
	if (YellowObjective2.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (YellowObjective2.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (YellowObjective2.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}

	else if (%team==4)
	{
	if (RedObjective2.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (RedObjective2.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (RedObjective2.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}
	else if (%team==2)
	{
	if (BlueObjective2.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (BlueObjective2.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (BlueObjective2.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}
	else if (%team==8)
	{
	if (PurpleObjective2.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (PurpleObjective2.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (PurpleObjective2.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}
	else return " ";
}

function getObjective3Status(%team)
{
	if (%team==1)
	{
	if (YellowObjective3.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (YellowObjective3.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (YellowObjective3.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}

	else if (%team==4)
	{
	if (RedObjective3.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (RedObjective3.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (RedObjective3.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}
	else if (%team==2)
	{
	if (BlueObjective3.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (BlueObjective3.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (BlueObjective3.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}
	else if (%team==8)
	{
	if (PurpleObjective3.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (PurpleObjective3.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (PurpleObjective3.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}
	else return " ";
}

function getObjective4Status(%team)
{
	if (%team==1)
	{
	if (YellowObjective4.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (YellowObjective4.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (YellowObjective4.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}

	else if (%team==4)
	{
	if (RedObjective4.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (RedObjective4.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (RedObjective4.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}
	else if (%team==2)
	{
	if (BlueObjective4.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (BlueObjective4.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (BlueObjective4.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}
	else if (%team==8)
	{
	if (PurpleObjective4.status==*IDSTR_OBJ_COMPLETED)
		{return "COMPLETED";}
	else if (PurpleObjective4.status==*IDSTR_OBJ_ACTIVE)
		{return "ACTIVE";}
	else if (PurpleObjective4.status==*IDSTR_OBJ_FAILED)
		{return "FAILED";}
	else
		{return " ";}
	}
	else return " ";
}

function getPlayersVeh(%who)
{
	if (checkIfPlayerDead(%who)=="NOT ON") return "NONE";
	return getVehicleName(playerManager::playerNumToVehicleId(%who));
}

function countSguns(%who)
{
	if (checkIfPlayerDead(%who)=="NOT ON") return "N/A";
	%vehicle= playerManager::playerNumToVehicleId(%who);
	%max= getWeaponCount(%vehicle);
	%count=0;
	for(%n=0; %n<%max; %n++)
	{
		if(getWeaponId(%vehicle,%n)==150)
		%count++;
	}
	return %count;
}

function calculateMass(%who)
{
	if (checkIfPlayerDead(%who)=="NOT ON") return "N/A";
	%vehicle= playerManager::playerNumToVehicleId(%who);
	%massLeft= getVehicleAvailableMass(%vehicle);
	%totalMass= calculateTotalMass(%vehicle);
	%mass= %totalMass-%massLeft+0.1;
	return %mass;
}

function calculateTotalMass(%what)
{
	%type= getVehicleName(%what);
	if (%type=="Talon") return 30;
	if (%type=="Knight's Talon") return 30;
	if (%type=="Minotaur") return 40;
	if (%type=="Knight's Minotaur") return 40;
	if (%type=="Basilisk") return 50;
	if (%type=="Knight's Basilisk") return 50;
	if (%type=="Apocalpyse") return 60;
	if (%type=="Knight's Apocalypse") return 60;
	if (%type=="Gorgon") return 80;
	if (%type=="Knight's Gorgon") return 80;
	if (%type=="Emancipator") return 40;
	if (%type=="Outrider Emancipator") return 40;
	if (%type=="Olympian") return 75;
	if (%type=="Avenger") return 30;
	if (%type=="Dreadlock") return 45;
	if (%type=="Disrupter") return 55;
	if (%type=="Myrmidon") return 90;
	if (%type=="Paladin") return 60;
	if (%type=="Knight's Disrupter") return 55;
	if (%type=="Knight's Myrmidon") return 90;
	if (%type=="Knight's Paladin") return 60;
	if (%type=="Harabec's Predator") return 60;
	if (%type=="Seeker") return 25;
	if (%type=="Metagen Seeker") return 25;
	if (%type=="Goad") return 35;
	if (%type=="Metagen Goad") return 35;
	if (%type=="Shepherd") return 48;
	if (%type=="Metagen Shepherd") return 48;
	if (%type=="Adjudicator") return 60;
	if (%type=="Platinum Guard Adjudicator") return 60;
	if (%type=="Executioner") return 90;
	if (%type=="Platinum Guard Executioner") return 90;
	if (%type=="Bolo") return 35;
	if (%type=="Recluse") return 40;
	return 60;
}

function calculateCombatValue(%who)
{
	if (checkIfPlayerDead(%who)=="NOT ON") return "N/A";
	%vehicle= playerManager::playerNumToVehicleId(%who);
	%baseValue= findBaseCombatValue(%vehicle);
	%weaponValue= calculateTotalWeaponValue(%vehicle);
	%componentValue= calculateTotalComponentValue(%vehicle);
	%total= %baseValue+ %weaponValue+ %componentValue;
	echo(%baseValue); echo(%weaponValue); echo(%componentValue);
	return %total;
}

function findBaseCombatValue(%what)
{
	%type= getVehicleName(%what);
	if (%type=="Talon") return 1000;
	if (%type=="Knight's Talon") return 2075;
	if (%type=="Minotaur") return 1300;
	if (%type=="Knight's Minotaur") return 1650;
	if (%type=="Basilisk") return 2000;
	if (%type=="Knight's Basilisk") return 2325;
	if (%type=="Apocalpyse") return 2540;
	if (%type=="Knight's Apocalypse") return 2670;
	if (%type=="Gorgon") return 3350;
	if (%type=="Knight's Gorgon") return 3805;
	if (%type=="Emancipator") return 1730;
	if (%type=="Outrider Emancipator") return 1730;
	if (%type=="Olympian") return 3150;
	if (%type=="Avenger") return 1830;
	if (%type=="Dreadlock") return 2215;
	if (%type=="Disrupter") return 2700;
	if (%type=="Myrmidon") return 3035;
	if (%type=="Paladin") return 2005;
	if (%type=="Knight's Disrupter") return 2880;
	if (%type=="Knight's Myrmidon") return 3215;
	if (%type=="Knight's Paladin") return 2300;
	if (%type=="Harabec's Predator") return 3510;
	if (%type=="Seeker") return 1205;
	if (%type=="Metagen Seeker") return 1205;
	if (%type=="Goad") return 1600;
	if (%type=="Metagen Goad") return 1600;
	if (%type=="Shepherd") return 1810;
	if (%type=="Metagen Shepherd") return 1810;
	if (%type=="Adjudicator") return 2705;
	if (%type=="Platinum Guard Adjudicator") return 2850;
	if (%type=="Executioner") return 3600;
	if (%type=="Platinum Guard Executioner") return 3835;
	if (%type=="Bolo") return 1470;
	if (%type=="Recluse") return 1720;
	return -10000;
}

function calculateTotalWeaponValue(%what)
{
	%max= getWeaponCount(%what);
	%value=0;
	for(%n=0; %n<%max; %n++)
	{
		%amount= calculateWeaponValue(getWeaponId(%what,%n));
		%value= %value+ %amount;
	}
	return %value;
}

function calculateWeaponValue(%id)
{
	if (%id==3) return 600;
	if (%id==101) return 435;
	if (%id==102) return 700;
	if (%id==103) return 570;
	if (%id==104) return 495;
	if (%id==105) return 610;
	if (%id==106) return 820;
	if (%id==107) return 755;
	if (%id==108) return 865;
	if (%id==109) return 900;
	if (%id==110) return 1025;
	if (%id==111) return 785;
	if (%id==112) return 1135;
	if (%id==113) return 1225;
	if (%id==114) return 600;
	if (%id==115) return 660;
	if (%id==116) return 400;
	if (%id==117) return 610;
	if (%id==118) return 520;
	if (%id==119) return 920;
	if (%id==120) return 1015;
	if (%id==121) return 975;
	if (%id==124) return 605;
	if (%id==125) return 700;
	if (%id==126) return 490;
	if (%id==127) return 560;
	if (%id==128) return 630;
	if (%id==129) return 840;
	if (%id==130) return 800;
	if (%id==131) return 410;
	if (%id==132) return 450;
	if (%id==133) return 490;
	if (%id==134) return 400;
	if (%id==135) return 425;
	if (%id==136) return 450;
	if (%id==142) return 770;
	if (%id==147) return 595;
	if (%id==150) return 625;
	if (%id==0) return 0;
	return -10000;
}

function calculateTotalComponentValue(%what)
{
	%max= getComponentCount(%what);
	%value=0;
	for(%n=0; %n<%max; %n++)
	{
		%amount= calculateComponentValue(getComponentId(%what,%n));
		%value= %value+ %amount;
	}
	return %value;
}

function calculateComponentValue(%id)
{
	if (%id==100) return 506;
	if (%id==101) return 537;
	if (%id==102) return 620;
	if (%id==103) return 620;
	if (%id==104) return 669;
	if (%id==105) return 716;
	if (%id==106) return 759;
	if (%id==107) return 780;
	if (%id==108) return 800;
	if (%id==109) return 839;
	if (%id==110) return 876;
	if (%id==111) return 930;
	if (%id==112) return 980;
	if (%id==113) return 1012;
	if (%id==114) return 1058;
	if (%id==115) return 1073;
	if (%id==127) return 506;
	if (%id==129) return 566;
	if (%id==130) return 593;
	if (%id==131) return 620;
	if (%id==132) return 645;
	if (%id==133) return 693;
	if (%id==134) return 716;
	if (%id==135) return 750;
	if (%id==136) return 763;
	if (%id==137) return 792;
	if (%id==138) return 839;
	if (%id==139) return 912;
	if (%id==140) return 947;
	if (%id==141) return 1012;
	if (%id==142) return 1043;
	if (%id==143) return 1073;
	if (%id==200) return 410;
	if (%id==201) return 450;
	if (%id==202) return 503;
	if (%id==203) return 578;
	if (%id==204) return 588;
	if (%id==205) return 845;
	if (%id==225) return 398;
	if (%id==226) return 438;
	if (%id==227) return 513;
	if (%id==228) return 588;
	if (%id==229) return 575;
	if (%id==230) return 730;
	if (%id==300) return 639;
	if (%id==301) return 719;
	if (%id==302) return 843;
	if (%id==303) return 1161;
	if (%id==304) return 926;
	if (%id==305) return 1163;
	if (%id==306) return 1025;
	if (%id==307) return 1447;
	if (%id==310) return 639;
	if (%id==327) return 671;
	if (%id==328) return 787;
	if (%id==329) return 887;
	if (%id==330) return 1045;
	if (%id==331) return 1305;
	if (%id==332) return 1119;
	if (%id==333) return 1462;
	if (%id==400) return 131;
	if (%id==401) return 143;
	if (%id==408) return 181;
	if (%id==409) return 259;
	if (%id==410) return 351;
	if (%id==411) return 250;
	if (%id==412) return 139;
	if (%id==413) return 214;
	if (%id==414) return 192;
	if (%id==426) return 117;
	if (%id==427) return 133;
	if (%id==428) return 158;
	if (%id==429) return 224;
	if (%id==430) return 251;
	if (%id==431) return 211;
	if (%id==432) return 114;
	if (%id==433) return 214;
	if (%id==434) return 208;
	if (%id==800) return 25;
	if (%id==801) return 100;
	if (%id==802) return 150;
	if (%id==805) return 75;
	if (%id==806) return 150;
	if (%id==807) return 200;
	if (%id==810) return 700;
	if (%id==811) return 900;
	if (%id==812) return 800;
	if (%id==813) return 1000;
	if (%id==820) return 1075;
	if (%id==830) return 850;
	if (%id==831) return 1125;
	if (%id==840) return 1200;
	if (%id==845) return 500;
	if (%id==850) return 825;
	if (%id==860) return 500;
	if (%id==865) return 1000;
	if (%id==870) return 450;
	if (%id==875) return 400;
	if (%id==880) return 675;
	if (%id==885) return 875;
	if (%id==890) return 3000;
	if (%id==900) return 425;
	if (%id==910) return 1250;
	if (%id==912) return 915;
	if (%id==914) return 750;
	if (%id==926) return 773;
	if (%id==927) return 844;
	if (%id==928) return 1367;
	if (%id==929) return 1182;
	if (%id==930) return 1257;
	if (%id==931) return 1480;
	if (%id==0) return 0;
	return -10000;
}

function checkIfPlayerDead(%who)
{
	%vehicle= playerManager::playerNumToVehicleId(%who);
	if (( %vehicle != "" ) && (isGroupDestroyed (%vehicle) == false))	//Player Alive and well
		{return "ALIVE";}
	else if ( %vehicle == "" )	//Player does not have a vehicle
		{return "NOT ON";}
	else return "DEAD";
}


function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");

   // Player ScoreBoard column headings
   $ScoreBoard::PlayerColumnHeader1 = "Squad";
   $ScoreBoard::PlayerColumnHeader2 = "Team";
   $ScoreBoard::PlayerColumnHeader3 = "Status";
   $ScoreBoard::PlayerColumnHeader4 = "Kills";
   $ScoreBoard::PlayerColumnHeader5 = "Vehicle";
//   $ScoreBoard::PlayerColumnHeader6 = "Combat Value";
//   $ScoreBoard::PlayerColumnHeader7 = "SGUNs";		//Some people would be interested!

   // Player ScoreBoard column functions
   $ScoreBoard::PlayerColumnFunction1 = "getSquad";
   $ScoreBoard::PlayerColumnFunction2 = "getTeam";
   $ScoreBoard::PlayerColumnFunction3 = "checkIfPlayerDead";
   $ScoreBoard::PlayerColumnFunction4 = "getKills";
   $ScoreBoard::PlayerColumnFunction5 = "getPlayersVeh";
//   $ScoreBoard::PlayerColumnFunction6 = "calculateCombatValue";
//   $ScoreBoard::PlayerColumnFunction7 = "countSguns";
   

   // Team ScoreBoard column headings
   $ScoreBoard::TeamColumnHeader1 = "Objective 1";
   $ScoreBoard::TeamColumnHeader2 = "Objective 2";
   $ScoreBoard::TeamColumnHeader3 = "Objective 3";
   $ScoreBoard::TeamColumnHeader4 = "Objective 4";

   // Team ScoreBoard column functions
   $ScoreBoard::TeamColumnFunction1 = "getObjective1Status";
   $ScoreBoard::TeamColumnFunction2 = "getObjective2Status";
   $ScoreBoard::TeamColumnFunction3 = "getObjective3Status";
   $ScoreBoard::TeamColumnFunction4 = "getObjective4Status";

   // tell server to process all the scoreboard definitions defined above
   serverInitScoreBoard();
}
///////////////////////////////Miscellaneous Functions///////////////////////////////////////////////////////////////////////
function displayObjectives(%who)
{
	%team= getTeam(%who);
        %string= "PRIMARY OBJECTIVES\n";
	%primary=true;
        if (%team==*IDSTR_TEAM_YELLOW)
	{
	if ((YellowObjective1.status != *IDSTR_OBJ_IGNORE)&&(YellowObjective1.status != false)) %string= %string@YellowObjective1.status @"          "@ YellowObjective1.shortTxt@"\n";
	if ((!YellowObjective2.isPrimary)&&(%primary)) {%string=%string@"SECONDARY OBJECTIVES\n"; %primary=false;}
	if ((YellowObjective2.status != *IDSTR_OBJ_IGNORE)&&(YellowObjective2.status != false)) %string= %string@YellowObjective2.status @"          "@ YellowObjective2.shortTxt@"\n";
	if ((!YellowObjective3.isPrimary)&&(%primary)) {%string=%string@"SECONDARY OBJECTIVES\n"; %primary=false;}
	if ((YellowObjective3.status != *IDSTR_OBJ_IGNORE)&&(YellowObjective3.status != false)) %string= %string@YellowObjective3.status @"          "@ YellowObjective3.shortTxt@"\n";
	if ((!YellowObjective4.isPrimary)&&(%primary)) {%string=%string@"SECONDARY OBJECTIVES\n"; %primary=false;}
	if ((YellowObjective4.status != *IDSTR_OBJ_IGNORE)&&(YellowObjective4.status != false)) %string= %string@YellowObjective4.status @"          "@ YellowObjective4.shortTxt@"\n";
	}

        else if (%team==*IDSTR_TEAM_RED)
	{
	if ((RedObjective1.status != *IDSTR_OBJ_IGNORE)&&(RedObjective1.status != false)) %string= %string@RedObjective1.status @"          "@ RedObjective1.shortTxt@"\n";
	if ((!RedObjective2.isPrimary)&&(%primary)) {%string=%string@"SECONDARY OBJECTIVES\n"; %primary=false;}
	if ((RedObjective2.status != *IDSTR_OBJ_IGNORE)&&(RedObjective2.status != false)) %string= %string@RedObjective2.status @"          "@ RedObjective2.shortTxt@"\n";
	if ((!RedObjective3.isPrimary)&&(%primary)) {%string=%string@"SECONDARY OBJECTIVES\n"; %primary=false;}
	if ((RedObjective3.status != *IDSTR_OBJ_IGNORE)&&(RedObjective3.status != false)) %string= %string@RedObjective3.status @"          "@ RedObjective3.shortTxt@"\n";
	if ((!RedObjective4.isPrimary)&&(%primary)) {%string=%string@"SECONDARY OBJECTIVES\n"; %primary=false;}
	if ((RedObjective4.status != *IDSTR_OBJ_IGNORE)&&(RedObjective4.status != false)) %string= %string@RedObjective4.status @"          "@ RedObjective4.shortTxt@"\n";
	}

        else if (%team==*IDSTR_TEAM_BLUE)
	{
	if ((BlueObjective1.status != *IDSTR_OBJ_IGNORE)&&(BlueObjective1.status != false)) %string= %string@BlueObjective1.status @"          "@ BlueObjective1.shortTxt@"\n";
	if ((!BlueObjective2.isPrimary)&&(%primary)) {%string=%string@"SECONDARY OBJECTIVES\n"; %primary=false;}
	if ((BlueObjective2.status != *IDSTR_OBJ_IGNORE)&&(BlueObjective2.status != false)) %string= %string@BlueObjective2.status @"          "@ BlueObjective2.shortTxt@"\n";
	if ((!BlueObjective3.isPrimary)&&(%primary)) {%string=%string@"SECONDARY OBJECTIVES\n"; %primary=false;}
	if ((BlueObjective3.status != *IDSTR_OBJ_IGNORE)&&(BlueObjective3.status != false)) %string= %string@BlueObjective3.status @"          "@ BlueObjective3.shortTxt@"\n";
	if ((!BlueObjective4.isPrimary)&&(%primary)) {%string=%string@"SECONDARY OBJECTIVES\n"; %primary=false;}
	if ((BlueObjective4.status != *IDSTR_OBJ_IGNORE)&&(BlueObjective4.status != false)) %string= %string@BlueObjective4.status @"          "@ BlueObjective4.shortTxt@"\n";
	}

        else if (%team==*IDSTR_TEAM_PURPLE)
	{
	if ((PurpleObjective1.status != *IDSTR_OBJ_IGNORE)&&(PurpleObjective1.status != false)) %string= %string@PurpleObjective1.status @"          "@ PurpleObjective1.shortTxt@"\n";
	if ((!PurpleObjective2.isPrimary)&&(%primary)) {%string=%string@"SECONDARY OBJECTIVES\n"; %primary=false;}
	if ((PurpleObjective2.status != *IDSTR_OBJ_IGNORE)&&(PurpleObjective2.status != false)) %string= %string@PurpleObjective2.status @"          "@ PurpleObjective2.shortTxt@"\n";
	if ((!PurpleObjective3.isPrimary)&&(%primary)) {%string=%string@"SECONDARY OBJECTIVES\n"; %primary=false;}
	if ((PurpleObjective3.status != *IDSTR_OBJ_IGNORE)&&(PurpleObjective3.status != false)) %string= %string@PurpleObjective3.status @"          "@ PurpleObjective3.shortTxt@"\n";
	if ((!PurpleObjective4.isPrimary)&&(%primary)) {%string=%string@"SECONDARY OBJECTIVES\n"; %primary=false;}
	if ((PurpleObjective4.status != *IDSTR_OBJ_IGNORE)&&(PurpleObjective4.status != false)) %string= %string@PurpleObjective4.status @"          "@ PurpleObjective4.shortTxt@"\n";
	}
        messageBox(%who, %string);
}

//-----------------------------------------------------------------------------
function MPTeamCheckBoundary( %dir, %obj2, %distance, %team, %callback, %time )
{
// This is a modification of the multiplayercampaign function "MPCheckBoundary"
// This function will check if anybody on a particulat team fullfills the distance requirements
//
// %dir  - enter or leave
// %obj2 - any object you want the players distance compared to
//         must be an ID (use getObjectid) and not a string ("MissionGroup/RedHerc/h1")
// %distance - if entering, they'd be within this range to run the function
//             if leaving, they'd be outside this range to run the function
// %callback - name of the function to run
// %time - when to reschedule the next check

%jobRun = false;

%playerCount = playerManager::getPlayerCount();

for(%i=0; %i < %playerCount ; %i++)
{
	%player = playerManager::getPlayerNum( %i );
	%obj1= playerManager::playerNumToVehicleId( %player);
	%var = getDistance( %obj1, %obj2 );
	if ((getTeam(%obj1)==%team)&&(checkIfPlayerDead(%player)=="ALIVE"))	//Skip distance checking if wrong team or dead player
	{
	if (%var != "0")
	{
		if( %dir == "enter" || %dir == "Enter" )
		{
			if(( %var <= %distance )&&(!%jobrun))
			{
//			%func = %callback @ "(" @ %obj1 @ ");";
//			schedule( %func, 0 );
			schedule(%callback,0);
			%jobRun = true;
			}
		}
		else if( %dir == "leave" || %dir == "Leave" )
		{
			if(( %var >= %distance )&&(!%jobrun))	//Game will not start unless each team has a player
			{
			if (allTeamsFilled())
			{
//				%func = %callback @ "();";
//				schedule( %func, 0 );
				schedule(%callback,0);
				%jobRun = true;
			}
			else	//not all teams filled
			{
				damageObject(%obj1,30000);
				say(%player,0,"Wait for somebody to join the other team before starting.");
				//%jobrun not changed because job not run
			}
			}
		}
	}
	}
} // end for loop

if  (%jobRun != true )
{
	schedule( "MPTeamcheckBoundary( \""@ %dir @"\", "@ %obj2 @ ", "@ %distance @ ", \""@ %team @"\",\""@ %callback @ "\", "@ %time @ ");",%time );
}
}

//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)			//Loops until the end or until player is found
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         return %playerVeh;
       }
     }
  return 0;
}
//-----------------------------------------------------------------------------
function checkThatTeamReports(%team, %obj1,%task)
{
	%playerCount = playerManager::getPlayerCount();
	echo(%playerCount@" players");
	%total = 0;	//Number of players alive on team
	for(%p = 0; %p < %playerCount; %p++)
	{
	%player = playerManager::getPlayerNum(%p);
        if ((getTeam(%player)== %team)&&(checkIfPlayerDead(%player)=="ALIVE")) %total++;
	}
	echo(%total@" alive");
 	%howManyAreClose = 0;

	for (%p = 0; %p < %playerCount; %p++)
	{
	%player = playerManager::getPlayerNum( %p );
	%playerVeh = playerManager::playerNumToVehicleId( %player);
	%var = getDistance( %obj1, %playerVeh );
	if ( %var < 300 ) %howManyAreClose++;
	}
	echo(%howManyAreClose@" at Nav");
	if ( %howManyAreClose >= %total ) 	//Yes, it has happened. LOL!
	{
	schedule(%task,0);
	}
	else
	{
	schedule ("checkThatTeamReports(\""@%team@"\","@%obj1@",\""@%task@"\");", 10 );
	}
}

function playerLoop(%task1, %task2, %team)
{
	for(%i=0;%i<playerManager::getPlayerCount();%i++)
	{
	%player= playerManager::getPlayerNum(%i);
//	fileWrite("multiplayer\\serverlog.txt", append, "LINE 1250 OK @ i="@%i);
	if ((getTeam(%player)==%team)||(%team=="all"))
		schedule(%task1@%player@%task2,0);
	}
}

function countLiving(%team)		//this cannot be used in checkThatTeamReports because it returns a percentage
{
	%total=0; %living=0;
	for(%i=0;%i<playerManager::getPlayerCount();%i++)
	{
	%player= playerManager::getPlayerNum(%i);
	if(getTeam(%player)==%team)
		{
		%total++;
		if (checkIfPlayerDead(%player)=="ALIVE")
			%living++;
		}
	}
	%percent= 100*%living/%total;
	return %percent;
}

function remotehoverswitch(%who)	//Triggerable by pressing ctrl+D on the herc boost keymap
{
	displayObjectives(%who);
}

function logPlayerList()
{
	for(%i=0;%i<playerManager::getPlayerCount();%i++)
	{
	%player= playerManager::getPlayerNum(%i);
	%outputString= "\n"@ getTeam(%player) @": "@ getName(%player) @" in a "@ getVehicleName(playerManager::playerNumToVehicleId(%player));
	fileWrite("multiplayer\\serverlog.txt", append, %outputString);
	}
}

function announce(%string)	//Admin command
{
	echo("ADMIN: " @ %string);	//so the admin sees it, too
	say(0,0,"<F2>ADMIN:<F3> " @ %string);
}

function getWeaponName(%id)
{
	if (%id==3) return "Disrupter Cannon";
	if (%id==101) return "Laser";
	if (%id==102) return "Heavy Laser";
	if (%id==103) return "Compression Laser";
	if (%id==104) return "Twin Laser";
	if (%id==105) return "Electromagnetic Pulse Cannon";
	if (%id==106) return "Electron Flux Whip";
	if (%id==107) return "Blaster";
	if (%id==108) return "Heavy Blaster";
	if (%id==109) return "Particle Beam Weapon";
	if (%id==110) return "Plasma Cannon";
	if (%id==111) return "Blink Gun";
	if (%id==112) return "Quantum Gun";
	if (%id==113) return "Magneto-Fusion Assault Cannon";
	if (%id==114) return "Nano-Infuser";
	if (%id==115) return "Nanite Cannon";
	if (%id==116) return "Autocannon";
	if (%id==117) return "Heavy Autocannon";
	if (%id==118) return "Electromagnetic Autocannon";
	if (%id==119) return "Blast Cannon";
	if (%id==120) return "Heavy Blast Cannon";
	if (%id==121) return "Railgun";
	if (%id==124) return "Pit Viper 8-Pack";
	if (%id==125) return "Pit Viper 12-Pack";
	if (%id==126) return "Sparrow 6-Pack";
	if (%id==127) return "Sparrow 10-Pack";
	if (%id==128) return "Swarm 6-Pack";
	if (%id==129) return "Minion Missile";
	if (%id==130) return "Shrike Missile";
	if (%id==131) return "Arachnitron 6-Pack";
	if (%id==132) return "Arachnitron 10-Pack";
	if (%id==133) return "Arachnitron 14-Pack";
	if (%id==134) return "Proximity 6-Pack";
	if (%id==135) return "Proximity 8-Pack";
	if (%id==136) return "Proximity 10-Pack";
	if (%id==142) return "Radiation Gun";
	if (%id==147) return "Aphid Missile";
	if (%id==150) return "Smart Gun";
	if (%id==0) return "NONE";
}

function getComponentName(%id)
{
	if (%id==100) return "Light Engine";
	if (%id==101) return "Light High Output Engine";
	if (%id==102) return "Light Agility Engine";
	if (%id==103) return "Medium Engine";
	if (%id==104) return "Medium High Output Engine";
	if (%id==105) return "Medium Agility Engine";
	if (%id==106) return "Heavy Engine";
	if (%id==107) return "Improved Heavy Engine";
	if (%id==108) return "Heavy Cruise Engine";
	if (%id==109) return "Heavy High Output Engine";
	if (%id==110) return "Heavy Agility Engine";
	if (%id==111) return "Standard Assault Engine";
	if (%id==112) return "Improved Assault Engine";
	if (%id==113) return "Heavy Turbine Engine";
	if (%id==114) return "High Output Turbine Engine";
	if (%id==115) return "Super Heavy Engine";
	if (%id==127) return "Alpha Engine";
	if (%id==129) return "Beta Engine";
	if (%id==130) return "Gamma Engine";
	if (%id==131) return "Delta Engine";
	if (%id==132) return "Epsilon Engine";
	if (%id==133) return "Zeta Engine";   
	if (%id==134) return "Eta Engine";
	if (%id==135) return "Theta Engine";
	if (%id==136) return "Iota Engine";   
	if (%id==137) return "Kappa Engine";
	if (%id==138) return "Lambda Engine";
	if (%id==139) return "Mu Engine";
	if (%id==140) return "Nu Engine";
	if (%id==141) return "Xi Engine";
	if (%id==142) return "Omicron Engine";
	if (%id==143) return "Pi Engine";
	if (%id==200) return "Micro Reactor";
	if (%id==201) return "Small Reactor";
	if (%id==202) return "Standard Reactor";
	if (%id==203) return "Medium Reactor";
	if (%id==204) return "Large Reactor";
	if (%id==205) return "Maxim Reactor";
	if (%id==225) return "Alpha Reactor";
	if (%id==226) return "Beta Reactor";
	if (%id==227) return "Gamma Reactor";
	if (%id==228) return "Delta Reactor";
	if (%id==229) return "Epsilon Reactor";
	if (%id==230) return "Zeta Reactor";
	if (%id==300) return "Standard Shield Generator";
	if (%id==301) return "Protector Shield Generator";
	if (%id==302) return "Guardian Shield Generator";
	if (%id==303) return "FastCharge Shield Generator";
	if (%id==304) return "Centurion Shield Generator";
	if (%id==305) return "Repulsor Shield Generator";
	if (%id==306) return "Titan Shield Generator";
	if (%id==307) return "Medusa Shield Generator";
	if (%id==310) return "Alpha Shield Generator";
	if (%id==327) return "Beta Shield Generator";
	if (%id==328) return "Gamma Shield Generator";
	if (%id==329) return "Delta Shield Generator";
	if (%id==330) return "Epsilon Shield Generator";
	if (%id==331) return "Zeta Shield Generator";   
	if (%id==332) return "Eta Shield Generator";
	if (%id==333) return "Theta Shield Generator";
	if (%id==400) return "Basic Sensor";
	if (%id==401) return "Ranger Sensor";
	if (%id==408) return "Standard Sensor";
	if (%id==409) return "Longbow Sensor";
	if (%id==410) return "Infiltrator Sensor";
	if (%id==411) return "Crossbow Sensor";
	if (%id==412) return "Ultralight Sensor";
	if (%id==413) return "Bloodhound Sensor";
	if (%id==414) return "Emission Scanning Sensor";
	if (%id==426) return "Alpha Sensor";
	if (%id==427) return "Beta Sensor";
	if (%id==428) return "Gamma Sensor";
	if (%id==429) return "Delta Sensor";
	if (%id==430) return "Epsilon Sensor";
	if (%id==431) return "Zeta Sensor";   
	if (%id==432) return "Eta Sensor";
	if (%id==433) return "Theta Sensor";
	if (%id==434) return "Iota Sensor";   
	if (%id==800) return "Basic Computer";
	if (%id==801) return "Intermediate Computer";
	if (%id==802) return "Advanced Computer";
	if (%id==805) return "Alpha Computer";
	if (%id==806) return "Beta Computer";
	if (%id==807) return "Gamma Computer";
	if (%id==810) return "Guardian ECM";
	if (%id==811) return "Doppelganger ECM";
	if (%id==812) return "Alpha ECM";
	if (%id==813) return "Beta ECM";
	if (%id==820) return "Thermal Diffuser";
	if (%id==830) return "Chameleon Cloak";
	if (%id==831) return "Cuttlefish Cloak";
	if (%id==840) return "Shield Modulator";
	if (%id==845) return "Shield Capitator";
	if (%id==850) return "Shield Amplifier";
	if (%id==860) return "Laser Target Designation System";
	if (%id==865) return "Auxillary Energy Reserve";
	if (%id==870) return "Reactor Capitator";
	if (%id==875) return "Field Stabilizer";
	if (%id==880) return "Rocket Booster";
	if (%id==885) return "Tubine Booster";
	if (%id==890) return "Nanorepair Module";
	if (%id==900) return "Angel Life Support System";
	if (%id==910) return "Anti-Gravity Module";
	if (%id==912) return "Electrohull";
	if (%id==914) return "Universal Ammo Pack";
	if (%id==926) return "CARLAM Armor";
	if (%id==927) return "Quad-Bonded Metaplas Armor";
	if (%id==928) return "DURAC Armor";
	if (%id==929) return "Ceramic Armor";
	if (%id==930) return "Crystaluminum Armor";
	if (%id==931) return "Quicksilver Armor";
	if (%id==0) return "NONE";
}

function dungatsCloneVehicle(%globalVarName, %old, %x, %y, %z)	//an abridged version of trevorsCloneVehicle()
{
   %clone = cloneVehicle(%old);
   setPosition(%clone, %x, %y, %z);
   schedule( "deleteObject(" @ %old @ ");", 5);
   schedule( %globalVarName @ " = " @ %clone @ ";", 0);
   addToSet( "MissionGroup", %clone );
}

function fadeToYellow()
{
	fadeEvent(0, "out", 10, 0.5, 0.5, 0);
}

function fadeToRed()
{
	fadeEvent(0, "out", 10, 0.5, 0, 0);
}

function fadeToBlue()
{
	fadeEvent(0, "out", 10, 0, 0, 0.5);
}

function fadeToPurple()
{
	fadeEvent(0, "out", 10, 0.345, 0.1254, 0.254);
}

function fadeToNeutral()
{
	fadeEvent(0, "out", 10, 0.5, 0.5, 0.5);
}

function allTeamsFilled()
{
	%red=false; %blue=false; %purple=false; %yellow=false;
	%total=PlayerManager::getPlayerCount();
	for(%i=0; %i<%total; %i++)
	{
	%player=playerManager::getPlayerNum(%i);
	%vehicle= playerManager::playerNumToVehicleId(%player);
		if (getTeam(%player)==*IDSTR_TEAM_YELLOW) %yellow=true;
		if (getTeam(%player)==*IDSTR_TEAM_RED) %red=true;
		if (getTeam(%player)==*IDSTR_TEAM_BLUE) %blue=true;
		if (getTeam(%player)==*IDSTR_TEAM_PURPLE) %purple=true;
	}
	if ($RedRace=="NONE") %red=true;	//to avoid halts by nonexistent teams
	if ($BlueRace=="NONE") %blue=true;
	if ($PurpleRace=="NONE") %purple=true;
	if ($YellowRace=="NONE") %yellow=true;
	if ((%yellow)&&(%red)&&(%purple)&&(%blue)) return true;
	else return false;
}

function deletePlayerVehicles()		//To prevent immediate mission start before deletion of old vehicles
{
	playerLoop("deleteObject(playerManager::PlayerNumToVehicleId(","));","all");
}

function setTeamMarker(%nav,%status,%team)	//setNavMarker wont work for this; i've tried it
{
	for(%i=0;%i<playerManager::getPlayerCount();%i++)
	{
	%player= playerManager::getPlayerNum(%i);
	%vehicle= playerManager::PlayerNumToVehicleId(%player);
	if (getTeam(%vehicle)==%team)
		{
		setNavMarker(%nav,%status,%player);
//		schedule("setNavMarker("@%nav@","@%status@",-1);",0);
//		echo("setNavMarker("@%nav@","@%status@",-1);");
		}
	}
}

function help::structure::onScan(%target, %scanner, %string)
{
	%string1= "The object of the Multi-Team Campaign game is to complete your mission objectives before the other"
		@" team can complete theirs. Speed usually isn't a problem, since their objectives and yours are "
		@"probably mutually exclusive: you can't complete both.";
	%string2= "There are three ways you can read your objectives. The first is the mission briefing you just "
		@"read. The second screen of each briefing is a basic list of the objectives. If you blew over it, I "
		@"suggest you respawn and read it.";
	%string3= "The second way is by going to the scoreboard. Although the scoreboard does not provide objective "
		@"descriptions, it lets you see how many objectives the other team has completed.";
	%string4= "The third way is only available if you have the herc boost keymap (it's in the latest MIB map "
		@"pack). If you have it, pressing ctrl+D will give you a message box similar to the kind found in "
		@"single-player games.";
	%string5= "Next, respawning. Limited respawning is permitted withh \"reinforcement waves\". Reinforcement "
		@"waves allow anybody who isn't alive at the time to join. Your team will be notified when this "
		@"happens. Don't expect more than one reinforcement wave.";
	%string6= "Step out of the start area to begin the game, unless otherwise indicated.";
	messageBox(%scanner, %string1);
	messageBox(%scanner, %string2);
	messageBox(%scanner, %string3);
	messageBox(%scanner, %string4);
	messageBox(%scanner, %string5);
	messageBox(%scanner, %string6);
}